#include <stdint.h>
#include <stdio.h>
#include <math.h>

#include "acrtclib.c"

int main(void)
{
    puts("\nGraphics Demo3 V1.00\n");

    mode11();
    cls(1);
    org();

uint16_t vo=4;             /* margin - vertical offset */
uint16_t ho=4;             /* margin - horizontal offset */
uint16_t hs=320,vs=236;    /* horizontal & vertical shift */

    mode11_colour(1);

    rectangle(0,0,acrtc_hr-1,acrtc_vr-1);              /* draw border */
    line(0,vo,acrtc_hr-1,vo);                          /* draw top & bottom margins */
    line(0,acrtc_vr-1-vo,acrtc_hr-1,acrtc_vr-1-vo);
    line(ho,0,ho,acrtc_vr-1);                          /* draw left & right margins */
    line(acrtc_hr-1-ho,0,acrtc_hr-1-ho,acrtc_vr-1);

// draw spiral

double xp=144;
double xr=4.71238905;
double xf=xr/xp;

double zi=0;
double zt=0;
double zs=0;
double xl=0;
double xi=0;
double xt=0;
double yy=0;

uint16_t x=0;
uint16_t y=0;

    for(zi=-64;zi<=64;zi++)
    {
        zt=zi*2.25;
        zs=zt*zt;
        xl=(int)(sqrt(20736-zs)+0.5);
        for(xi=0-xl;xi<=xl;xi++)
        {
            xt=sqrt(xi*xi+zs)*xf;
            yy=(sin(xt)+sin(xt*3)*0.4)*56;
            x=(uint16_t)xi+zi+hs;
            y=(uint16_t)vs-yy+zi;
            mode11_colour(1);
            dot(x,y);
            mode11_colour(0);
            line(x,y+1,x,acrtc_vr-135);
        }
    }
    puts("Graphics Rendering Complete!\n");
    return 0;
}
